<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Modules
 */
/**************************************************************************/

class BoardModule_Admin extends A_MainFrame
{
/**
 * Конструктор.
 */

  function __construct()
  {
    parent::__construct("module_board.tpl");

	$this->AddJScript("/modules/board/admin/board.js");
	$this->AddJScript("/system/objcomp/jscripts/images.js");
  }

/**
 * Маршрутизатор действий.
 */

  function Action($action)
  {
    switch($action)
    { case "additem": $res=$this->AddItem(); break;
  	  case "edititem": $res=$this->EditItem(); break;
	  case "delitem": $res=$this->DelItem(); break;
	  case "setrows": $res=$this->setRows(); break;
	  case "setsort": $res=$this->setSort(); break;
	  case "setfilter": $res=$this->setFilter(); break;
	  case "unfilter": $res=$this->unFilter(); break;
	  case "setactive": $res=$this->SetActive(); break;
	  case "setunactive": $res=$this->SetUnActive(); break;
	  case "delete": $res=$this->Delete(); break;
	  case "moveitems": $res=$this->MoveItems(); break;
	}
    if(!empty($res))
	A::goUrl("admin.php?mode=sections&item=".SECTION,array('idcat','tab','page'));
  }

/**
 * Обработчик действия: Способ сортировки.
 */

  function setSort()
  {
    A_Session::set(SECTION."_sort",$_REQUEST['sort']);
	setcookie(SECTION."_sort",$_REQUEST['sort'],time()+31104000);
	return true;
  }

/**
 * Обработчик действия: Количество строк на странице.
 */

  function setRows()
  {
	A_Session::set(SECTION."_rows",$_REQUEST['rows']);
	setcookie(SECTION."_rows",$_REQUEST['rows'],time()+31104000);
	return true;
  }

/**
 * Обработчик действия: Установка фильтра.
 */

  function setFilter()
  {
    $data=array();
	$data['active']=true;
    $data['name']=A::$DB->real_escape_string($_REQUEST['name']);
	$data['date']=isset($_REQUEST['date']);
	$data['iduser']=(integer)$_REQUEST['iduser'];
	$data['date1']=(integer)$_REQUEST['from'];
	$data['date2']=(integer)$_REQUEST['to'];
    $data['status']=A::$DB->real_escape_string($_REQUEST['status']);
	$this->fieldseditor_setfilter($data);
	A_Session::set(SECTION."_filter",$data);
	return true;
  }

/**
 * Обработчик действия: Сброс фильтра.
 */

  function unFilter()
  {
    $data=array("active"=>false,"name"=>"","date"=>false,"iduser"=>"","status"=>0);
  	$date1=A::$DB->getOne("SELECT MIN(date) FROM ".SECTION."_catalog");
	$data['date1']=$date1>0?$date1:time();
	$data['date2']=time();
	$this->fieldseditor_unfilter($data);
	A_Session::set(SECTION."_filter",$data);
    return true;
  }

/**
 * Обработчик действия: Добавление записи.
 */

  function AddItem()
  {
    if(!empty($_REQUEST['idcat']))
    { if(is_array($_REQUEST['idcat']))
      { $idcats=array();
	    foreach($_REQUEST['idcat'] as $idcat)
	    $idcats[]=(integer)$idcat;
      }
      else
      $idcats=array((integer)$_REQUEST['idcat']);
    }
    else
    return false;
    $idcats=array_unique($idcats);

    $_REQUEST['date']=time();
	if($users=getSectionByModule("users"))
	if($user=trim($_REQUEST['user']))
	$_REQUEST['iduser']=A::$DB->getOne("SELECT id FROM {$users} WHERE login=?",$user);
    if(empty($_REQUEST['iduser']))
	$_REQUEST['iduser']=(integer)$_REQUEST['user'];
	$_REQUEST['name']=strclear($_REQUEST['name']);
	$_REQUEST['bbcode']=$_REQUEST['content'];
    $_REQUEST['content']=parse_bbcode($_REQUEST['content']);
    $_REQUEST['active']=isset($_REQUEST['active'])?'Y':'N';

	$dataset = new A_DataSet(SECTION."_catalog",true);
    $dataset->fields=array("date","iduser","name","bbcode","content","active");
    if($id=$dataset->Insert())
	{
	  for($i=1;$i<=5;$i++)
	  if(isset($_REQUEST["imagedescription$i"]))
	  UploadImage("image$i",$_REQUEST["imagedescription$i"],0,$id,$i);

	  foreach($idcats as $idcat)
	  if($idcat)
      A::$DB->Insert(SECTION,array('idcat'=>$idcat,'iditem'=>$id));

      $this->updateCategoryItems($idcats);

      if($_REQUEST['active']=='Y')
	  A::$OBSERVER->Event('searchIndexUpdate',SECTION,array('id'=>$id,'name'=>$_REQUEST['name'],'content'=>$_REQUEST['content']));

	  unset($_POST['idcat']);

	  return true;
	}
	else
	return false;
  }

/**
 * Обработчик действия: Изменение записи.
 */

  function EditItem()
  {
    if(!empty($_REQUEST['idcat']))
    { if(is_array($_REQUEST['idcat']))
      { $idcats=array();
	    foreach($_REQUEST['idcat'] as $idcat)
	    $idcats[]=(integer)$idcat;
      }
      else
      $idcats=array((integer)$_REQUEST['idcat']);
    }
    else
    return false;
    $idcats=array_unique($idcats);

    $_REQUEST['date']=time();
	if($users=getSectionByModule("users"))
	if($user=trim($_REQUEST['user']))
	$_REQUEST['iduser']=A::$DB->getOne("SELECT id FROM {$users} WHERE login=?",$user);
    if(empty($_REQUEST['iduser']))
	$_REQUEST['iduser']=(integer)$_REQUEST['user'];
	$_REQUEST['name']=strclear($_REQUEST['name']);
	$_REQUEST['bbcode']=$_REQUEST['content'];
    $_REQUEST['content']=parse_bbcode($_REQUEST['content']);
	$_REQUEST['active']=isset($_REQUEST['active'])?'Y':'N';

	$dataset = new A_DataSet(SECTION."_catalog",true);
    $dataset->fields=array("iduser","name","bbcode","content","active");
    if($row=$dataset->Update())
	{
	  $_idcats=A::$DB->getCol("SELECT idcat FROM ".SECTION." WHERE iditem={$row['id']}");
	  $__idcats=array();

	  foreach($_idcats as $idcat)
	  if($idcat && !in_array($idcat,$idcats))
	  { A::$DB->Delete(SECTION,"idcat=$idcat AND iditem={$row['id']}");
	    $__idcats[$idcat]=true;
	  }

	  foreach($idcats as $idcat)
	  if($idcat && !in_array($idcat,$_idcats))
	  { A::$DB->Insert(SECTION,array('idcat'=>$idcat,'iditem'=>$row['id']));
	    $__idcats[$idcat]=true;
	  }

	  $__idcats=array_keys($__idcats);

	  if($_REQUEST['active']!=$row['active'])
	  $this->updateCategoryItems(array_unique(array_merge($idcats,$_idcats)));
	  elseif($__idcats)
	  $this->updateCategoryItems($__idcats);

	  if($_REQUEST['active']=='Y')
	  A::$OBSERVER->Event('searchIndexUpdate',SECTION,array('id'=>$row['id'],'name'=>$_REQUEST['name'],'content'=>$_REQUEST['content']));
	  else
	  A::$OBSERVER->Event('searchIndexDelete',SECTION,array('id'=>$row['id']));

	  unset($_POST['idcat']);

	  return true;
	}
	else
	return false;
  }

/**
 * Обработчик действия: Удаление записи.
 *
 * @param integer $id=0 Идентификатор записи.
 */

  function DelItem($id=0)
  {
	if($id>0)
	$_REQUEST['id']=$id;

    $dataset = new A_DataSet(SECTION."_catalog",true);
    if($row=$dataset->Delete())
	{
	  DelRegSectionItemImages(SECTION_ID,$row['id']);

	  A::$OBSERVER->Event('searchIndexDelete',SECTION,array('id'=>$row['id']));

	  if($id==0)
	  { $idcats=A::$DB->getCol("SELECT DISTINCT idcat FROM ".SECTION." WHERE iditem={$row['id']}");
	    A::$DB->Delete(SECTION,"iditem={$row['id']}");
		$this->updateCategoryItems($idcats);
	  }
	  else
	  A::$DB->Delete(SECTION,"iditem={$row['id']}");

	  return true;
	}
	else
	return false;
  }

/**
 * Обновление количества записей в категории.
 *
 * @param integer $idcat Идентификатор категории.
 */

  function updateCategoryItems($idcat)
  { static $cache=array();
	if(is_array($idcat))
	{ foreach($idcat as $_idcat)
	  self::updateCategoryItems($_idcat);
	}
	elseif($idcat>0 && !isset($cache[$idcat]))
	if($category=A::$DB->getRowById($idcat,SECTION."_categories"))
    { $count=A::$DB->getOne("
	  SELECT COUNT(DISTINCT s.iditem)
	  FROM ".SECTION." AS s
	  LEFT JOIN ".SECTION."_catalog AS c ON c.id=s.iditem
	  WHERE s.idcat=$idcat AND c.active='Y'");
	  $subcount=A::$DB->getOne("SELECT SUM(citems) FROM ".SECTION."_categories WHERE idker={$idcat} AND active='Y'");
      $citems=$count+$subcount;
      $sub=$citems-$category['citems'];
      A::$DB->Update(SECTION."_categories",array('citems'=>$citems),"id=".$category['id']);
      while($category['idker']>0)
      if($category=A::$DB->getRowById($category['idker'],SECTION."_categories"))
      A::$DB->Update(SECTION."_categories",array('citems'=>$category['citems']+$sub),"id=".$category['id']);
      $cache[$idcat]=true;
    }
  }

/**
 * Обработчик события: Удаление ветки категорий.
 *
 * @param string $section Полный строковой идентификатор раздела.
 * @param array $params Параметры события.
 */

  function DeleteCategory($section,$params)
  {
    @set_time_limit(0);

	$counts=A::$DB->getAssoc("SELECT iditem,COUNT(idcat) FROM ".SECTION."
	WHERE iditem IN(SELECT DISTINCT iditem FROM ".SECTION." WHERE idcat={$params['id']}) GROUP BY iditem");
	$iditems=A::$DB->getAssoc("SELECT DISTINCT iditem FROM ".SECTION." WHERE idcat={$params['id']}");

    foreach($iditems as $iditem)
	if(isset($counts[$iditem]) && $counts[$iditem]==1)
    self::DelItem($row['id']);

	A::$DB->Delete(SECTION,"idcat={$params['id']}");

	self::updateCategoryItems($params['idker']);
  }

/**
 * Обработчик события: Перемещение категории.
 *
 * @param string $section Полный строковой идентификатор раздела.
 * @param array $params Параметры события.
 */

  function MoveCategory($section,$params)
  {
	self::updateCategoryItems($params['idker']);
	self::updateCategoryItems($params['idto']);
  }

/**
 * Обработчик действия: Включение группы записей.
 */

  function SetActive()
  {
    if(!empty($_REQUEST['checkitem']))
	{ $cats=array();
	  foreach($_REQUEST['checkitem'] as $id)
	  if($row=A::$DB->getRowById($id,SECTION."_catalog"))
	  { A::$DB->execute("UPDATE ".SECTION."_catalog SET active='Y' WHERE id={$row['id']}");
	    A::$OBSERVER->Event('searchIndexUpdate',SECTION,array('id'=>$row['id'],'name'=>$row['name'],'content'=>$row['content']));
	    $cats=array_merge($cats,A::$DB->getCol("SELECT DISTINCT idcat FROM ".SECTION." WHERE iditem={$row['id']}"));
	  }
	  $cats=array_unique($cats);
	  foreach($cats as $idcat)
	  $this->updateCategoryItems($idcat);
	}
	return true;
  }

/**
 * Обработчик действия: Выключение группы записей.
 */

  function SetUnActive()
  {
    if(!empty($_REQUEST['checkitem']))
	{ $cats=array();
	  foreach($_REQUEST['checkitem'] as $id)
	  if($row=A::$DB->getRowById($id,SECTION."_catalog"))
	  { A::$DB->execute("UPDATE ".SECTION."_catalog SET active='N' WHERE id={$row['id']}");
	    A::$OBSERVER->Event('searchIndexDelete',SECTION,array('id'=>$row['id']));
	    $cats=array_merge($cats,A::$DB->getCol("SELECT DISTINCT idcat FROM ".SECTION." WHERE iditem={$row['id']}"));
	  }
	  $cats=array_unique($cats);
	  foreach($cats as $idcat)
	  $this->updateCategoryItems($idcat);
	}
	return true;
  }

/**
 * Обработчик действия: Удаление группы записей.
 */

  function Delete()
  {
    if(!empty($_REQUEST['checkitem']))
	{ $cats=array();
	  foreach($_REQUEST['checkitem'] as $id)
	  if($row=A::$DB->getRowById($id,SECTION."_catalog"))
	  { $cats=array_merge($cats,A::$DB->getCol("SELECT DISTINCT idcat FROM ".SECTION." WHERE iditem={$row['id']}"));
	    $this->DelItem($row['id']);
	  }
	  $cats=array_unique($cats);
	  foreach($cats as $idcat)
	  $this->updateCategoryItems($idcat);
	}
	return true;
  }

/**
 * Обработчик действия: Перемещение группы записей.
 */

  function MoveItems()
  {
	$idto=(integer)$_REQUEST['idto'];
	$idfrom=(integer)$_REQUEST['idfrom'];

	if($idfrom!=$idto && !empty($_REQUEST['checkitem']))
	foreach($_REQUEST['checkitem'] as $id)
	if($data=A::$DB->getRowById($id,SECTION."_catalog"))
	A::$DB->Update(SECTION,array('idcat'=>$idto),"idcat={$idfrom} AND iditem={$data['id']}");

	$this->updateCategoryItems($idfrom);
	$this->updateCategoryItems($idto);

	return true;
  }

/**
 * Формирование условия SQL запроса по текущим фильтрам.
 *
 * @return string
 */

  function getFilter()
  {
    $data=A_Session::get(SECTION."_filter",array());
    $where=array();
	if($data['active'])
	{ if(!empty($data['name']))
	  $where[]="c.name LIKE '%{$data['name']}%'";
	  if($data['date'])
	  $where[]="c.date>={$data['date1']} AND c.date<={$data['date2']}";
	  if(!empty($data['iduser']))
	  $where[]="c.iduser='{$data['iduser']}'";
	  if(!empty($data['status']))
	  $where[]="c.active='{$data['status']}'";
	  $where=$this->adminfilter(implode(" AND ",$where),$data,'c.');
	}
    return $where;
  }

/**
 * Формирование данных доступных в шаблоне.
 */

  function createData()
  {
    if(!A_Session::is_set(SECTION."_filter"))
    $this->unFilter();

	$categories=A::$DB->getAll("SELECT id,idker,name FROM ".SECTION."_categories ORDER BY level,sort");
	$this->Assign("categories",$categories);

	if(!empty($_GET['idcat']))
	{ $this->Assign("category",A::$DB->getRowById($_GET['idcat'],SECTION."_categories"));
	  $idcat=(integer)$_GET['idcat'];
	  $idcats=array($idcat);
	  getTreeSubItems(SECTION."_categories",$idcat,$idcats);
	}

	$filter=$this->getFilter();

	$rows=(integer)A_Session::get(SECTION."_rows",isset($_COOKIE[SECTION.'_rows'])?$_COOKIE[SECTION.'_rows']:20);
	$sort=escape_order_string(A_Session::get(SECTION."_sort",isset($_COOKIE[SECTION.'_sort'])?$_COOKIE[SECTION.'_sort']:A::$OPTIONS['sort']));

    $this->Assign("userssection",$users=getSectionByModule('users'));

	$items=array();
	$pager = new A_Pager($rows);
	$pager->tab="items";
	if(!empty($idcats))
	$pager->query("
	SELECT DISTINCT s.iditem AS sid,c.*
	FROM ".SECTION." AS s
	LEFT JOIN ".SECTION."_catalog AS c ON c.id=s.iditem
	WHERE s.idcat IN(".implode(",",$idcats).")".($filter?" AND $filter":"")."
	ORDER BY $sort");
	else
    $pager->query("
	SELECT *
	FROM ".SECTION."_catalog AS c
	".($filter?"WHERE $filter":"")."
	ORDER BY $sort");
	while($row=$pager->fetchRow())
	{ $row['link']=board_createItemLink($row['id'],SECTION);
	  if(A::$OPTIONS['useimages'])
	  { $row['images']=A::$DB->getAll("SELECT * FROM ".DOMAIN."_images WHERE idsec=? AND iditem=? ORDER BY sort",array(SECTION_ID,$row['id']));
	    $row['idimg']=isset($row['images'][0]['id'])?$row['images'][0]['id']:0;
	  }
	  if($users && $row['iduser'])
	  $row['user']=A::$DB->getRowById($row['iduser'],$users);
	  if(empty($_GET['idcat']))
	  { if($idcats=A::$DB->getCol("SELECT DISTINCT idcat FROM ".SECTION." WHERE iditem={$row['id']} ORDER BY id"))
	    { $row['category']=A::$DB->getOne("SELECT name FROM ".SECTION."_categories WHERE id=".reset($idcats));
	      $row['catpath']=array();
		  foreach($idcats as $idcat)
		  $row['catpath'][]=getTreePath(SECTION."_categories",$idcat);
		  $row['catpath']='<li type="quard">'.implode('<li type="quard">',$row['catpath']);
	    }
	  }
	  $items[]=$row;
	}

	$this->Assign("items",$items);
	$this->Assign("items_pager",$pager);

	$this->Assign("treebox",new A_CategoriesTree("items"));

	$this->Assign("optbox1",new A_OptionsBox("Внешний вид на сайте:",array('idgroup'=>1)));
	$this->Assign("optbox2",new A_OptionsBox("Изображения:",array('idgroup'=>2)));
	$this->Assign("optbox3",new A_OptionsBox("Уведомления:",array('idgroup'=>3)));

	$this->Assign("fieldsbox",new A_FieldsEditor(SECTION."_catalog",array('tab'=>'opt','tab_opt'=>'fields'),true,true,true));

	$this->Assign("sort",$sort);
	$this->Assign("rows",$rows);
	$this->Assign("filter",!empty($filter));
  }
}

A::$OBSERVER->AddHandler('DeleteCategory',array('BoardModule_Admin','DeleteCategory'));
A::$OBSERVER->AddHandler('MoveCategory',array('BoardModule_Admin','MoveCategory'));

A::$MAINFRAME = new BoardModule_Admin;