<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Modules
 */
/**************************************************************************/

class BoardModule_Request extends A_Request
{
/**
 * Маршрутизатор действий.
 */

  function Action($action)
  {
    switch($action)
    { case "getadditemform": $this->getAddItemForm(); break;
	  case "getedititemform": $this->getEditItemForm(); break;
	  case "getmoveitemsform": $this->getMoveItemsForm(); break;
	  case "getfilterform": $this->getFilterForm(); break;
    }
  }

/**
 * Обработчик действия: Отдает форму добавления записи.
 */

  function getAddItemForm()
  {
    $form = new A_Form("module_board_add.tpl");
	$form->data['idcat']=(integer)$_POST['idcat'];
	$form->data['categories']=A::$DB->getAll("SELECT id,idker,name FROM ".SECTION."_categories ORDER BY level,sort");
	$form->fieldseditor_addprepare();
	$this->RESULT['html'] = $form->getContent();
  }

/**
 * Обработчик действия: Отдает форму редактирования записи.
 */

  function getEditItemForm()
  {
    $form = new A_Form("module_board_edit.tpl");
	$form->data=A::$DB->getRowById($_POST['id'],SECTION."_catalog");
	$form->data['categories']=A::$DB->getAll("SELECT id,idker,name FROM ".SECTION."_categories ORDER BY level,sort");
	$form->data['idcat']=A::$DB->getCol("SELECT DISTINCT idcat FROM ".SECTION." WHERE iditem={$form->data['id']} ORDER BY id");
	if($users=getSectionByModule("users"))
	$form->data['user']=A::$DB->getOne("SELECT login FROM {$users} WHERE id={$form->data['iduser']}");
    $form->fieldseditor_editprepare();
    $form->data['imagesbox'] = new A_Images((integer)$_POST['id']);
	$this->RESULT['html'] = $form->getContent();
  }

/**
 * Обработчик действия: Отдает форму фильтров.
 */

  function getFilterForm()
  {
    $data=A_Session::get(SECTION."_filter",array());
	$form = new A_Form("module_board_filter.tpl");
	$form->data['name']=$data['name'];
	$form->data['iduser']=$data['iduser'];
	$form->data['date']=$data['date'];
	$form->data['from']=$data['date1'];
	$form->data['to']=$data['date2'];
	$form->data['statuss']=array(0=>"Не выбрано","Y"=>"Активные","N"=>"Неактивные");
	$form->data['status']=$data['status'];
	$form->fieldseditor_filterprepare($data);
	$frame = new A_Frame("default_form.tpl","Фильтр",$form);
	$this->RESULT['html'] = $frame->getContent();
  }

/**
 * Обработчик действия: Отдает форму перемещения записей.
 */

  function getMoveItemsForm()
  {
    if(empty($_POST['items'])) return;
    $form = new A_Form("module_board_move.tpl");
	$form->data['idcat']=(integer)$_POST['idcat'];
	$form->data['items']=array_values($_POST['items']);
	$form->data['categories']=A::$DB->getAll("SELECT id,idker,name FROM ".SECTION."_categories ORDER BY level,sort");
	if($form->data['categories'])
	$this->RESULT['html']=$form->getContent();
	else
	$this->RESULT['html']=AddLabel("Нет вариантов перемещения.");
  }
}

A::$REQUEST = new BoardModule_Request;