<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Modules
 */
/**************************************************************************/

class BoardModule extends A_MainFrame
{
  public $idcat=0;
  public $category=0;
  public $iditem=0;
  public $itemdata=0;

  function Router($uri)
  {
	foreach($uri as $param)
	if(preg_match("/^(.+)\.html$/",$param,$match))
    switch($match[1])
	{ case "add":
	    $this->page="addform";
		return;
	  case "edit":
	    if($this->idcat==0)
	    $this->page="editform";
		return;
	  case "mypage":
	    if($this->idcat==0)
	    $this->page="mypage";
	    return;
	  default:
	    if($this->itemdata=A::$DB->getRow("SELECT * FROM ".SECTION."_catalog WHERE id=? AND active='Y'",(integer)$match[1]))
	    $this->iditem=$this->itemdata['id'];
	    else
	    A::NotFound();
    }
	else
	{ if($this->category=A::$DB->getRow("
	  SELECT * FROM ".SECTION."_categories
	  WHERE idker={$this->idcat} AND urlname=? AND active='Y'",$param))
      $this->idcat=$this->category['id'];
	  else
      A::NotFound();
    }

	if($this->iditem>0)
	$this->page="page";
	elseif($this->idcat>0)
	$this->page="category";
	else
	$this->page="main";
  }

  function Action($action)
  {
    switch($action)
	{ case "add": $this->AddItem();	break;
	  case "edit": $this->EditItem(); break;
	  case "del": $this->DelItem();	break;
	}
  }

  function AddItem()
  {
	if(!A::$AUTH->isLogin() || !getAccess("add"))
	return false;

    if(!empty($_REQUEST['idcat']))
    { if(is_array($_REQUEST['idcat']))
      { $idcats=array();
	    foreach($_REQUEST['idcat'] as $idcat)
	    $idcats[]=(integer)$idcat;
      }
      else
      $idcats=array((integer)$_REQUEST['idcat']);
    }
    else
    $idcats=array();

	$idcats=array_unique($idcats);

    if(!$idcats)
	{ $this->errors['emptycats']=true;
	  return false;
	}

    $_REQUEST['date']=time();
	$_REQUEST['iduser']=A::$AUTH->id;
	$_REQUEST['name']=strclear($_REQUEST['name']);
	$_REQUEST['bbcode']=$_REQUEST['content'];
    $_REQUEST['content']=parse_bbcode($_REQUEST['content']);
	$_REQUEST['active']=A::$OPTIONS['newactive']?'Y':'N';

	if(empty($_REQUEST['name']))
	{ $this->errors['emptyname']=true;
	  return false;
	}

	$dataset = new A_DataSet(SECTION."_catalog",true);
    $dataset->fields=array("date","iduser","name","bbcode","content","active");
    if($id=$dataset->Insert())
	{
	  if(A::$OPTIONS['useimages'])
	  { for($i=1;$i<=5;$i++)
	    UploadImage("image$i",$_REQUEST['name'],0,$id,$i);
	  }

	  foreach($idcats as $idcat)
	  if($idcat)
      A::$DB->Insert(SECTION,array('idcat'=>$idcat,'iditem'=>$id));

      $this->updateCategoryItems($idcats);

      if($_REQUEST['active']=='Y')
	  A::$OBSERVER->Event('searchIndexUpdate',SECTION,array('id'=>$id,'name'=>$_REQUEST['name'],'content'=>$_REQUEST['content']));

	  if(!empty(A::$OPTIONS['email']))
	  { $mail = new A_Mail(A::$OPTIONS['mail_new'],"html");
		$data=A::$DB->getRowById($id,SECTION."_catalog");
		$data['link']="http://".HOSTNAME.board_createItemLink($id,SECTION);
		prepareValues(SECTION,$data);
		$mail->Assign("data",$data);
		$mail->Assign("user",A::$AUTH->data);
	    $mail->send(A::$OPTIONS['email']);
	  }

	  A::goUrl(getSectionLink(SECTION)."mypage.html");
	}
	else
	return false;
  }

  function EditItem()
  {
	if(!A::$AUTH->isLogin() || !getAccess("edit"))
	return false;

	$dataset = new A_DataSet(SECTION."_catalog",true);
	$dataset->fields=array("name","bbcode","content","active");

	if(!$dataset->data || $dataset->data['iduser']!=A::$AUTH->id)
	return false;

	if(!empty($_REQUEST['idcat']))
    { if(is_array($_REQUEST['idcat']))
      { $idcats=array();
	    foreach($_REQUEST['idcat'] as $idcat)
	    $idcats[]=(integer)$idcat;
      }
      else
      $idcats=array((integer)$_REQUEST['idcat']);
    }
    else
    $idcats=array();

    $idcats=array_unique($idcats);

    if(!$idcats)
	{ $this->errors['emptycats']=true;
	  return false;
	}

    $_REQUEST['date']=time();
	$_REQUEST['name']=strclear($_REQUEST['name']);
	$_REQUEST['bbcode']=$_REQUEST['content'];
    $_REQUEST['content']=parse_bbcode($_REQUEST['content']);
	$_REQUEST['active']=A::$OPTIONS['newactive']?'Y':'N';

	if(empty($_REQUEST['name']))
	{ $this->errors['emptyname']=true;
	  return false;
	}

    if($data=$dataset->Update())
	{
	  if(A::$OPTIONS['useimages'])
	  { $images=A::$DB->getCol("SELECT id FROM ".DOMAIN."_images WHERE idsec=? AND iditem=? ORDER BY sort",array(SECTION_ID,$data['id']));
	    for($i=1;$i<=5;$i++)
	    UploadImage("image$i",$_REQUEST['name'],isset($images[$i-1])?$images[$i-1]:0,$data['id'],$i);
	  }

	  $_idcats=A::$DB->getCol("SELECT idcat FROM ".SECTION." WHERE iditem={$data['id']}");
	  $__idcats=array();

	  foreach($_idcats as $idcat)
	  if($idcat && !in_array($idcat,$idcats))
	  { A::$DB->Delete(SECTION,"idcat=$idcat AND iditem={$data['id']}");
	    $__idcats[$idcat]=true;
	  }

	  foreach($idcats as $idcat)
	  if($idcat && !in_array($idcat,$_idcats))
	  { A::$DB->Insert(SECTION,array('idcat'=>$idcat,'iditem'=>$data['id']));
	    $__idcats[$idcat]=true;
	  }

	  $__idcats=array_keys($__idcats);

	  if($_REQUEST['active']!=$data['active'])
	  $this->updateCategoryItems(array_unique(array_merge($idcats,$_idcats)));
	  elseif($__idcats)
	  $this->updateCategoryItems($__idcats);

	  if($_REQUEST['active']=='Y')
	  A::$OBSERVER->Event('searchIndexUpdate',SECTION,array('id'=>$data['id'],'name'=>$_REQUEST['name'],'content'=>$_REQUEST['content']));
	  else
	  A::$OBSERVER->Event('searchIndexDelete',SECTION,array('id'=>$data['id']));

	  if(!empty(A::$OPTIONS['email']))
	  { $mail = new A_Mail(A::$OPTIONS['mail_new']);
		$data=A::$DB->getRowById($data['id'],SECTION."_catalog");
		prepareValues(SECTION,$data);
		$mail->Assign("data",$data);
	    $mail->send(A::$OPTIONS['email']);
	  }

	  A::goUrl(getSectionLink(SECTION)."mypage.html");
	}
	return false;
  }

  function DelItem()
  {
	if(!A::$AUTH->isLogin() || !getAccess("del"))
	return false;

	$dataset = new A_DataSet(SECTION."_catalog",true);

	if(!$dataset->data || $dataset->data['iduser']!=A::$AUTH->id)
	return false;

	if($data=$dataset->Delete())
	{
	  DelRegSectionItemImages(SECTION_ID,$data['id']);
	  A::$OBSERVER->Event('searchIndexDelete',SECTION,array('id'=>$data['id']));

	  $idcats=A::$DB->getCol("SELECT DISTINCT idcat FROM ".SECTION." WHERE iditem={$data['id']}");
	  A::$DB->Delete(SECTION,"iditem={$data['id']}");

	  $this->updateCategoryItems($idcats);

	  A::goUrl(getSectionLink(SECTION)."mypage.html");
	}
	else
	return false;
  }

  function updateCategoryItems($idcat)
  { static $cache=array();
	if(is_array($idcat))
	{ foreach($idcat as $_idcat)
	  self::updateCategoryItems($_idcat);
	}
	elseif($idcat>0 && !isset($cache[$idcat]))
	if($category=A::$DB->getRowById($idcat,SECTION."_categories"))
    { $count=A::$DB->getOne("
	  SELECT COUNT(DISTINCT s.iditem)
	  FROM ".SECTION." AS s
	  LEFT JOIN ".SECTION."_catalog AS c ON c.id=s.iditem
	  WHERE s.idcat=$idcat AND c.active='Y'");
	  $subcount=A::$DB->getOne("SELECT SUM(citems) FROM ".SECTION."_categories WHERE idker={$idcat} AND active='Y'");
      $citems=$count+$subcount;
      $sub=$citems-$category['citems'];
      A::$DB->Update(SECTION."_categories",array('citems'=>$citems),"id=".$category['id']);
      while($category['idker']>0)
      if($category=A::$DB->getRowById($category['idker'],SECTION."_categories"))
      A::$DB->Update(SECTION."_categories",array('citems'=>$category['citems']+$sub),"id=".$category['id']);
      $cache[$idcat]=true;
    }
  }

  function createData()
  {
	switch($this->page)
	{ default:
	  case "main": $this->MainPage(); break;
	  case "category": $this->CategoryPage(); break;
	  case "page": $this->ItemPage(); break;
	  case "addform": $this->AddFormPage(); break;
	  case "editform": $this->EditFormPage(); break;
	  case "mypage": $this->MyPage(); break;
	}

	$this->Assign("mypagelink",getSectionLink(SECTION)."mypage.html");
	if(A::$AUTH->section)
	$this->Assign("registerlink",getSectionLink(A::$AUTH->section)."register.html");
  }

  function AddNavCategories($id)
  {
    if($id)
	{ if($row=A::$DB->getRow("SELECT id,idker,name FROM ".SECTION."_categories WHERE id=".(integer)$id))
	  { $this->title=$row['name'].(!empty($this->title)?" - ".$this->title:"");
	    $this->AddNavCategories($row['idker']);
	    $this->AddNavigation($row['name'],board_createCategoryLink($row['id'],SECTION));
	  }
	}
  }

  function MainPage()
  {
	$this->supportCached();

	$levels=A::$DB->getOne("SELECT MAX(level) FROM ".SECTION."_categories WHERE active='Y'");
	$this->Assign("levels",$levels);

	$categories=array();
    A::$DB->query("SELECT * FROM ".SECTION."_categories WHERE idker=0 AND active='Y' ORDER BY sort");
    while($row=A::$DB->fetchRow())
    { $row['link']=board_createCategoryLink($row['id'],SECTION);
	  $row['subcategories']=array();
      A::$DB->query("SELECT * FROM ".SECTION."_categories WHERE idker={$row['id']} AND active='Y' ORDER BY sort");
	  while($subrow=A::$DB->fetchRow())
	  { $subrow['link']=board_createCategoryLink($subrow['id'],SECTION);
	    $row['subcategories'][]=$subrow;
	  }
	  A::$DB->free();
	  $categories[]=$row;
    }
	A::$DB->free();
	$this->Assign("categories",$categories);

	if(getAccess("add"))
	$this->Assign("addlink",getSectionLink(SECTION)."add.html");

	$this->AddNavigation(SECTION_NAME);
  }

  function CategoryPage()
  {
	$this->supportCached();
	$this->addCacheParam_Get('page');

    $this->category['link']=board_createCategoryLink($this->idcat,SECTION);
	$this->Assign("category",$this->category);

	$categories=array();
    A::$DB->query("SELECT * FROM ".SECTION."_categories WHERE idker={$this->idcat} AND active='Y' ORDER BY sort");
    while($row=A::$DB->fetchRow())
    { $row['link']=board_createCategoryLink($row['id'],SECTION);
	  $row['subcategories']=array();
      A::$DB->query("SELECT * FROM ".SECTION."_categories WHERE idker={$row['id']} AND active='Y' ORDER BY sort");
	  while($subrow=A::$DB->fetchRow())
	  { $subrow['link']=board_createCategoryLink($subrow['id'],SECTION);
	    $row['subcategories'][]=$subrow;
	  }
	  A::$DB->free();
	  $categories[]=$row;
    }
	A::$DB->free();
	$this->Assign("categories",$categories);

	if(!empty($_REQUEST['sort']))
	A_Session::set(SECTION.'_sort',$_REQUEST['sort']);
	if(!empty($_REQUEST['rows']))
	A_Session::set(SECTION.'_rows',$_REQUEST['rows']);

	$sort=escape_order_string(A_Session::get(SECTION.'_sort',!empty(A::$OPTIONS['mysort'])?A::$OPTIONS['mysort']:A::$OPTIONS['sort']));
	$rows=(integer)A_Session::get(SECTION.'_rows',A::$OPTIONS['rows']);

	$this->Assign("rows",$rows);
	$this->Assign("sort",$sort);

	$filter=$this->frontfilter();

	$idcats=array($this->idcat);
	getTreeSubItems(SECTION."_categories",$this->idcat,$idcats);

	$items=array();
	$pager = new A_Pager($rows);
	$pager->query("
	SELECT DISTINCT s.iditem AS sid,c.*
	FROM ".SECTION." AS s
	LEFT JOIN ".SECTION."_catalog AS c ON c.id=s.iditem
	WHERE s.idcat IN(".implode(",",$idcats).")".($filter?" $filter":"")." AND c.active='Y'
	ORDER BY $sort");
    while($row=$pager->fetchRow())
    { $row['link']=board_createItemLink($row['id'],SECTION);
      $row['categories']=array();
	  if($idcats=A::$DB->getCol("SELECT DISTINCT idcat FROM ".SECTION." WHERE iditem={$row['id']} ORDER BY id"))
      foreach($idcats as $idcat)
	  $row['categories'][]=array('name'=>getTreePath(SECTION."_categories",$idcat),'link'=>board_createCategoryLink($idcat,SECTION));
	  if(A::$OPTIONS['useimages'])
	  { $row['images']=A::$DB->getAll("SELECT * FROM ".DOMAIN."_images WHERE idsec=? AND iditem=? ORDER BY sort",array(SECTION_ID,$row['id']));
	    $row['idimg']=isset($row['images'][0]['id'])?$row['images'][0]['id']:0;
	  }
	  prepareValues(SECTION,$row);
	  $row=A::$OBSERVER->Modifier('board_prepareValues',SECTION,$row);
      $items[]=$row;
    }
    $pager->free();

	$this->Assign("items",$items);
	$this->Assign("items_pager",$pager);

	$this->AddNavigation(SECTION_NAME,getSectionLink(SECTION));
	$this->AddNavCategories($this->category['idker']);
	$this->AddNavigation($this->category['name']);

	if(getAccess("add"))
	$this->Assign("addlink",$this->category['link']."add.html");

	$this->title=$this->category['name'].(!empty($this->title)?" - ".$this->title:"");
	$this->description=$this->category['description'];
  }

  function ItemPage()
  {
	$this->supportCached();

	$categories=array();
	if($idcats=A::$DB->getCol("SELECT DISTINCT idcat FROM ".SECTION." WHERE iditem={$this->iditem} ORDER BY id"))
    foreach($idcats as $idcat)
	$categories[]=array('name'=>getTreePath(SECTION."_categories",$idcat),'link'=>board_createCategoryLink($idcat,SECTION));
	$this->itemdata['categories']=$categories;

	if(A::$OPTIONS['useimages'])
	{ $this->itemdata['images']=A::$DB->getAll("SELECT * FROM ".DOMAIN."_images WHERE idsec=? AND iditem=? ORDER BY sort",array(SECTION_ID,$this->iditem));
	  $this->itemdata['idimg']=isset($this->itemdata['images'][0]['id'])?$this->itemdata['images'][0]['id']:0;
	}

	prepareValues(SECTION,$this->itemdata);

	$this->itemdata=A::$OBSERVER->Modifier('board_prepareValues',SECTION,$this->itemdata);

	$this->Assign("item",$this->itemdata);

	$this->AddNavigation(SECTION_NAME,getSectionLink(SECTION));
	$this->AddNavCategories($this->idcat);

    if(getAccess("add"))
	$this->Assign("addlink",$this->category['link']."add.html");

    $this->title=$this->itemdata['name'].(!empty($this->title)?" - ".$this->title:"");
    $this->description=$this->itemdata['content'];
  }

  function getCategories(&$values,$id,$owner="")
  {
    A::$DB->query("SELECT * FROM ".SECTION."_categories WHERE idker={$id} AND active='Y' ORDER BY sort");
	if(A::$DB->numRows())
	{ if(!empty($owner))
	  $owner.="&nbsp;&raquo;&nbsp;";
	  while($row=A::$DB->fetchRow())
      { $values[$row['id']]=$owner.$row['name'];
        $this->getCategories($values,$row['id'],$owner.$row['name']);
      }
	}
	A::$DB->free();
  }

  function AddFormPage()
  {
	if(!empty($_POST))
	$form=$_POST;
	else
	{ $form=A::$AUTH->data;
	  if(isset($form['name']))
	  unset($form['name']);
	}
	if(empty($form['idcat']))
	$form['idcat'][]=$this->idcat;
	$form['categories']=array();
	$this->getCategories($form['categories'],0);
	$this->Assign("form",$form);
	$this->prepareAddForm();

	$this->AddNavigation(SECTION_NAME,getSectionLink(SECTION));
	$this->AddNavCategories($this->idcat);
  }

  function EditFormPage()
  {
	if(!A::$AUTH->isLogin() || empty($_GET['id']))
	A::goUrl(getSectionLink(SECTION));

	if($form=A::$DB->getRowById($_GET['id'],SECTION."_catalog"))
	{ $form['content']=$form['bbcode'];
	  $form['idcat']=A::$DB->getCol("SELECT DISTINCT idcat FROM ".SECTION." WHERE iditem={$form['id']} ORDER BY id");
	  if(A::$OPTIONS['useimages'])
	  { $form['images']=A::$DB->getAll("SELECT * FROM ".DOMAIN."_images WHERE idsec=? AND iditem=? ORDER BY sort",array(SECTION_ID,$form['id']));
	    $form['idimg']=isset($form['images'][0]['id'])?$form['images'][0]['id']:0;
	  }
	}
	$form['categories']=array();
	$this->getCategories($form['categories'],0);
	$this->Assign("form",$form);
	$this->prepareEditForm($form);

	$this->AddNavigation(SECTION_NAME,getSectionLink(SECTION));
  }

  function MyPage()
  {
    if(!A::$AUTH->isLogin())
	A::goUrl(getSectionLink(SECTION));

    if(!empty($_REQUEST['sort']))
	A_Session::set(SECTION.'_sort',$_REQUEST['sort']);
	if(!empty($_REQUEST['rows']))
	A_Session::set(SECTION.'_rows',$_REQUEST['rows']);

	$sort=escape_order_string(A_Session::get(SECTION.'_sort',!empty(A::$OPTIONS['mysort'])?A::$OPTIONS['mysort']:A::$OPTIONS['sort']));
	$rows=(integer)A_Session::get(SECTION.'_rows',A::$OPTIONS['rows']);

	$this->Assign("rows",$rows);
	$this->Assign("sort",$sort);

	$edit = getAccess("edit");
	$del = getAccess("del");

	$items=array();
	$pager = new A_Pager($rows);
	$pager->query("SELECT * FROM ".SECTION."_catalog WHERE iduser=".A::$AUTH->id." ORDER BY $sort");
    while($row=$pager->fetchRow())
	{ if($edit)
      $row['editlink']=getSectionLink(SECTION)."edit.html?id=".$row['id'];
      if($del)
      $row['dellink']=getSectionLink(SECTION)."mypage.html?action=del&id=".$row['id'];
      if($row['active']=='Y')
	  $row['link']=board_createItemLink($row['id'],SECTION);
	  elseif(!empty($row['editlink']))
	  $row['link']=$row['editlink'];
      $row['categories']=array();
	  if($idcats=A::$DB->getCol("SELECT DISTINCT idcat FROM ".SECTION." WHERE iditem={$row['id']} ORDER BY id"))
      foreach($idcats as $idcat)
	  $row['categories'][]=array('name'=>getTreePath(SECTION."_categories",$idcat),'link'=>board_createCategoryLink($idcat,SECTION));
	  if(A::$OPTIONS['useimages'])
	  { $row['images']=A::$DB->getAll("SELECT * FROM ".DOMAIN."_images WHERE idsec=? AND iditem=? ORDER BY sort",array(SECTION_ID,$row['id']));
	    $row['idimg']=isset($row['images'][0]['id'])?$row['images'][0]['id']:0;
	  }
	  prepareValues(SECTION,$row);
	  $row=A::$OBSERVER->Modifier('board_prepareValues',SECTION,$row);
      $items[]=$row;
    }
    $pager->free();

	$this->Assign("items",$items);
	$this->Assign("items_pager",$pager);

    if(getAccess("add"))
	$this->Assign("addlink",getSectionLink(SECTION)."add.html");

	$this->AddNavigation(SECTION_NAME,getSectionLink(SECTION));
  }
}

if(A::$CACHE->page)
A::$CACHE->page->restore();

A::$MAINFRAME = new BoardModule;